Debian Bug report logs - #463123
e2fsprogs: grub 0.97 cannot boot ext3 filesystems with an inode size of 256 byte

version graph

Package: e2fsprogs; Maintainer for e2fsprogs is Theodore Y. Ts'o <tytso@mit.edu>; Source for e2fsprogs is src:e2fsprogs.

Reported by: Stefan Lippers-Hollmann <s.L-H@gmx.de>

Date: Tue, 29 Jan 2008 17:27:02 UTC

Severity: wishlist

Found in versions e2fsprogs/1.40.5-1, grub/0.97-29

Done: Theodore Tso <tytso@mit.edu>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Acknowledgement sent to Stefan Lippers-Hollmann <s.L-H@gmx.de>:
New Bug report received and forwarded. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Stefan Lippers-Hollmann <s.L-H@gmx.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Cc: Grub Maintainers <pkg-grub-devel@lists.alioth.debian.org>
Subject: e2fsprogs: grub 0.97 cannot boot ext3 filesystems with an inode size of 256 byte
Date: Tue, 29 Jan 2008 18:24:09 +0100
[Message part 1 (text/plain, inline)]
Package: e2fsprogs
Version: 1.40.5-1
Severity: wishlist

*** Please type your report below this line ***
Hi

ext3 filesystems with an inode size of 256 byte cannot be read by the 
read-only file system code of debian's/ upstream's grub 0.97 (e2fs_stage1_5 
can't be loaded). Given that e2fsprogs 1.40.5-1 has started to use 256 byte
inodes on default, creating new filesystems without explicitly decreasing 
the inode size creates filesystems which aren't bootable by current grub 
versions.

Fedora seems to have fixed this issue recently
http://cvs.fedora.redhat.com/viewcvs/devel/grub/grub-support-256byte-inode.patch?view=markup
which unfortunately depends on larger changes included in the following, 
rather monolithic, patch:
http://cvs.fedora.redhat.com/viewcvs/devel/grub/grub-fedora-9.patch?view=markup

It might be preferable to revert to smaller default inode sizes until this
issue is fixed in debian's grub(-legacy) packages.

Regards
	Stefan Lippers-Hollmann

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.24-slh64-smp-5 (SMP w/2 CPU cores; PREEMPT)
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages e2fsprogs depends on:
ii  e2fslibs                      1.40.5-1   ext2 filesystem libraries
ii  libblkid1                     1.40.5-1   block device id library
ii  libc6                         2.7-6      GNU C Library: Shared libraries
ii  libcomerr2                    1.40.5-1   common error description library
ii  libss2                        1.40.5-1   command-line interface parsing lib
ii  libuuid1                      1.40.5-1   universally unique id library

e2fsprogs recommends no packages.

-- no debconf information
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Acknowledgement sent to Theodore Tso <tytso@MIT.EDU>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #10 received at 463123@bugs.debian.org (full text, mbox):

From: Theodore Tso <tytso@MIT.EDU>
To: Stefan Lippers-Hollmann <s.L-H@gmx.de>, 463123@bugs.debian.org
Cc: Grub Maintainers <pkg-grub-devel@lists.alioth.debian.org>
Subject: Re: Bug#463123: e2fsprogs: grub 0.97 cannot boot ext3 filesystems with an inode size of 256 byte
Date: Wed, 30 Jan 2008 08:00:20 -0500
On Tue, Jan 29, 2008 at 06:24:09PM +0100, Stefan Lippers-Hollmann wrote:
> 
> ext3 filesystems with an inode size of 256 byte cannot be read by the 
> read-only file system code of debian's/ upstream's grub 0.97 (e2fs_stage1_5 
> can't be loaded). Given that e2fsprogs 1.40.5-1 has started to use 256 byte
> inodes on default, creating new filesystems without explicitly decreasing 
> the inode size creates filesystems which aren't bootable by current grub 
> versions.

It is highly desirable that new filesystems use 256 byte inodes, since
it provides for better forward compatibility with ext4, and it speeds
up extended attribute storage for systems that use SELinux and/or Samba4.

If the grub maintainers can't figure out a way to break up the
monolithic patch quickly, or to get it incorporated into Debian, or
get it upstreamed ASAP, one of the things that I could do is change
mke2fs.conf in the udeb file, so that it doesn't impact the Debian
installer.  Or better yet, the Anaconda could be hacked so that "-I
128" is passed to mke2fs just for the root filesystem, and not for
others.

But it really would be DoublePlusCool if we could get the 256 byte
inode support into Grub quickly, so we don't need to pursue these
workarounds.  If the grub folks could let me know what they think can
be pulled off, I would really appreciate it.

Thanks!!!!

							- Ted




Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Acknowledgement sent to Stefan Lippers-Hollmann <s.L-H@gmx.de>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #15 received at 463123@bugs.debian.org (full text, mbox):

From: Stefan Lippers-Hollmann <s.L-H@gmx.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Cc: 463123@bugs.debian.org, Grub Maintainers <pkg-grub-devel@lists.alioth.debian.org>, debian-boot@lists.debian.org
Subject: grub: does not support 256 byte inodes on ext3.
Date: Wed, 30 Jan 2008 15:01:55 +0100
[Message part 1 (text/plain, inline)]
Package: grub
Version: 0.97-29
Severity: normal

*** Please type your report below this line ***
Hi

ext3 filesystems with an inode size of 256 byte cannot be read by the 
read-only file system code of grub 0.97-29 (e2fs_stage1_5 can't be loaded).

Following up #463123 "e2fsprogs: grub 0.97 cannot boot ext3 filesystems 
with an inode size of 256 byte", I have reviewed the grub patches by Jesse 
Keating <jkeating@redhat.com> and Eric Sandeen <esandeen@redhat.com> 
staging up for Fedora 9:
http://cvs.fedora.redhat.com/viewcvs/devel/grub/grub-support-256byte-inode.patch?view=markup
which depends upon
http://cvs.fedora.redhat.com/viewcvs/devel/grub/grub-fedora-9.patch?view=markup
and came up with the attached patch, which allows grub(-legacy) 0.97 to 
boot from ext3 partitions with 256 byte inodes.

Even though I understand that grub(-legacy) is in feature freeze (grub2 
does already support booting from ext3 partitions with 256 byte inodes), I 
personally would prefer an update to grub 0.97, given that this issue 
leaves the (newly installed/ moved) system unbootable without any chance 
for manual interaction (grub neither installs and dies without any message)
and that the patch seems to be of reasonable size, while grub2 doesn't seem
to be ready for mass deployment.

The attached patch has been tested on several amd64 and i386 systems of 
varying (ext3) filesystem age and seems to work well with 128 byte and 256 
byte inode sizes.

Regards
	Stefan Lippers-Hollmann

CC'ing debian-boot on request of Robert Millan

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.24-slh64-smp-1 (SMP w/2 CPU cores; PREEMPT)
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

-- no debconf information
[grub-support-256byte-inode.diff (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Message #18 received at 463123@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@aybabtu.com>
To: Stefan Lippers-Hollmann <s.L-H@gmx.de>, 463236@bugs.debian.org
Cc: debian-boot@lists.debian.org, 463123@bugs.debian.org, Grub Maintainers <pkg-grub-devel@lists.alioth.debian.org>
Subject: Re: Bug#463236: grub: does not support 256 byte inodes on ext3.
Date: Wed, 30 Jan 2008 19:51:20 +0100
On Wed, Jan 30, 2008 at 03:01:55PM +0100, Stefan Lippers-Hollmann wrote:
> 
> Even though I understand that grub(-legacy) is in feature freeze

It's not just in feature freeze, that was months ago.  We're now preparing
to get rid of it.

Thanks for confirming that GRUB 2 is not affected.

-- 
Robert Millan

<GPLv2> I know my rights; I want my phone call!
<DRM> What use is a phone call… if you are unable to speak?
(as seen on /.)




Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Message #21 received at 463123@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@aybabtu.com>
To: debian-release@lists.debian.org
Cc: debian-boot@lists.debian.org, 463236@bugs.debian.org, 463123@bugs.debian.org
Subject: grub (legacy) and e2fsprogs
Date: Sun, 3 Feb 2008 01:41:02 +0100
Hi!

Please, can you make sure e2fsprogs-udeb >= 1.40.5-1 doesn't reach testing
before grub 0.97-30 (just uploaded) has?  Otherwise D-I builds will fail to
boot onto installed system.

For details see #463236, #463123.

Thanks

-- 
Robert Millan

<GPLv2> I know my rights; I want my phone call!
<DRM> What use is a phone call… if you are unable to speak?
(as seen on /.)




Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Acknowledgement sent to Otavio Salvador <otavio@debian.org>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #26 received at 463123@bugs.debian.org (full text, mbox):

From: Otavio Salvador <otavio@debian.org>
To: Robert Millan <rmh@aybabtu.com>
Cc: debian-release@lists.debian.org, debian-boot@lists.debian.org, 463236@bugs.debian.org, 463123@bugs.debian.org
Subject: Re: grub (legacy) and e2fsprogs
Date: Sun, 03 Feb 2008 16:58:16 -0200
Robert Millan <rmh@aybabtu.com> writes:

> Hi!
>
> Please, can you make sure e2fsprogs-udeb >= 1.40.5-1 doesn't reach testing
> before grub 0.97-30 (just uploaded) has?  Otherwise D-I builds will fail to
> boot onto installed system.
>
> For details see #463236, #463123.

I've added a note on the summary script to remember us of this restriction.

-- 
        O T A V I O    S A L V A D O R
---------------------------------------------
 E-mail: otavio@debian.org      UIN: 5906116
 GNU/Linux User: 239058     GPG ID: 49A5F855
 Home Page: http://otavio.ossystems.com.br
---------------------------------------------
"Microsoft sells you Windows ... Linux gives
 you the whole house."




Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Acknowledgement sent to 463123@bugs.debian.org, debian-boot@lists.debian.org:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #31 received at 463123@bugs.debian.org (full text, mbox):

From: Frans Pop <elendil@planet.nl>
To: 463123@bugs.debian.org
Cc: debian-boot@lists.debian.org
Subject: Re: Beta1 missing decisions and possible timeline
Date: Mon, 4 Feb 2008 02:22:35 +0100
[Message part 1 (text/plain, inline)]
Hello Ted,

On Wed, 30 Jan 2008 08:00:20 -0500, Ted Tso wrote:
> If the grub maintainers can't figure out a way to break up the
> monolithic patch quickly, or to get it incorporated into Debian, or
> get it upstreamed ASAP, one of the things that I could do is change
> mke2fs.conf in the udeb file, so that it doesn't impact the Debian
> installer.  Or better yet, the Anaconda could be hacked so that "-I

Please do not insult D-I by calling it Anaconda ;-)

> 128" is passed to mke2fs just for the root filesystem, and not for
> others.

You've probably seen that a new grub has been uploaded, which should solve 
this issue for unstable and etch.

However, there are also plans to use the Lenny Beta release of the installer 
for "Etch+1/2" installations: installs of Etch, but with a newer kernel 
(either 2.6.22 or 2.6.24).
As I don't expect the etch version of grub will be changed to support 256 
byte inodes, we need to solve this in the installer.

I already have a patch for this (and tested that it works), but would 
appreciate your confirmation on the solution. Note that this fix will not 
affect installs of lenny or sid.

Is it correct that _only_ grub and thus only i386 and amd64 are affected?
Or phrased differently, is it enough to only change the default back to 128 
for i386 and amd64, or should we also do that for other arches (even if 
just to be on the safe side)?

The "fix" I have is ATM to execute the following command (in the D-I 
environment) before the start of partitioning:
   sed -ir "s/(inode_size =) 256/\1 128/" /etc/mke2fs.conf

This works with the current conf file, but if needed I could make that a bit 
more generic, for example:
   sed -ir "s/(inode_size =) .*/\1 128/g" /etc/mke2fs.conf

What do you think?

In general, could you please keep the debian-boot list (or maybe even just 
d-d-a) informed if any other changes are planned that could affect people?

Cheers,
FJP
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Acknowledgement sent to Otavio Salvador <otavio@debian.org>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #36 received at 463123@bugs.debian.org (full text, mbox):

From: Otavio Salvador <otavio@debian.org>
To: 463123@bugs.debian.org
Cc: debian-boot@lists.debian.org
Subject: Re: Beta1 missing decisions and possible timeline
Date: Sun, 03 Feb 2008 23:36:15 -0200
Frans Pop <elendil@planet.nl> writes:

<...>
> You've probably seen that a new grub has been uploaded, which should solve 
> this issue for unstable and etch.
                              ^^^^ Lenny
<...>

-- 
        O T A V I O    S A L V A D O R
---------------------------------------------
 E-mail: otavio@debian.org      UIN: 5906116
 GNU/Linux User: 239058     GPG ID: 49A5F855
 Home Page: http://otavio.ossystems.com.br
---------------------------------------------
"Microsoft sells you Windows ... Linux gives
 you the whole house."




Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#463123; Package e2fsprogs. Full text and rfc822 format available.

Acknowledgement sent to Frans Pop <elendil@planet.nl>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #41 received at 463123@bugs.debian.org (full text, mbox):

From: Frans Pop <elendil@planet.nl>
To: 463123@bugs.debian.org
Cc: debian-boot@lists.debian.org
Subject: Re: Beta1 missing decisions and possible timeline
Date: Tue, 5 Feb 2008 20:24:05 +0100
[Message part 1 (text/plain, inline)]
On Monday 04 February 2008, Frans Pop wrote:
> You've probably seen that a new grub has been uploaded, which should
> solve this issue for unstable and etch^Wlenny.
>
> However, there are also plans to use the Lenny Beta release of the
> installer for "Etch+1/2" installations: installs of Etch, but with a
> newer kernel (either 2.6.22 or 2.6.24).
> As I don't expect the etch version of grub will be changed to support 256
> byte inodes, we need to solve this in the installer.

For the record, here are the most relevant parts of an IRC conversation I've 
just had with Ted Ts'o on this (copied with permission).
The resulting change for the etch-support udeb has already been committed.

[tytso] It would be nice to get the 256 byte inodes support sooner rather 
than later because it means significantly better performance for SELinux 
and Samba, plus the ext4 forwards compatibility.
[tytso] But if the new grub isn't going to make the etch point release, I 
guess we don't have a choice.
[fjp]   Are other arches known safe, or is it basically unknown whether 
there are any issues with 256 support?
[tytso] It probably makes sense to use the same default inode size for the 
root filesystem for all architectures, I agree.
[tytso] To be honest, I'm not sure if there are issues for the other 
architectures.
[tytso] We uncovered the grub issue on Fedora, since FC9 is going to ship 
with ext4 support, if all goes well.
[fjp]   OK. Then the only real option is to be conservative.
[tytso] Yes, I agree that conservative is the better choice here.
[fjp]   What about the sed command I use to change the default? Should that 
be safe for the next 6 months or so?
[fjp]   sed -ir "s/(inode_size =) 256/\1 128/" /etc/mke2fs.conf
[tytso] you'd want to change that before the lenny D-I beta to add ext4 
support.
[tytso] But for the etch + 0.5  D-I release, I assume once you snapshot the 
e2fsprogs.udeb, it wouldn't change from that point on, right?
[fjp]   Well, some installation methods pull the udeb from lenny mirrors at 
install time.
[tytso] Hmm.....
[fjp]   So I'd like to be safe against future changes in defaults in 
unstable/testing too.
[tytso] Well, in the next 2 months we will be adding ext4 support to 
e2fsprogs.   But if you make that a global search and replace, and not just 
replace the first instance of inode_size=256, it should be OK for the etch 
D-I.
[fjp]   I could also just snapshot the whole conf file and just replace it.
[tytso] that would be safer.
[fjp]   OK. Will do.
[signature.asc (application/pgp-signature, inline)]

Reply sent to Theodore Tso <tytso@mit.edu>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Stefan Lippers-Hollmann <s.L-H@gmx.de>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #46 received at 463123-done@bugs.debian.org (full text, mbox):

From: Theodore Tso <tytso@mit.edu>
To: 463123-done@bugs.debian.org
Subject: Re: Bug#463123: e2fsprogs: grub 0.97 cannot boot ext3 filesystems with an inode size of 256 byte
Date: Thu, 13 Mar 2008 09:42:34 -0400
At this point a new enough version of grub has been uploaded, and we
are in sync with the Debian Installer developers for the etch point
release, so I believe this bug can now be closed.

	      	      	       	       - Ted




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 11 Apr 2008 07:31:42 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 20:04:55 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.